#!/usr/bin/perl

###################################################################
# Whoson.pl
#
# Version:        1.2.2
# Original Mod by Sonic, updated by LoonyPandora. Special Thanks to Michael Prager
###################################################################

### Version Info ###
$YaBBversion = '1 Gold - SP 1.1';
$whosonplver = '1 Gold - SP 1.1';
######

&WhoHeader;

if ($INFO{'info'} eq 'Members') { &WhoMembers; } 
elsif ($INFO{'info'} eq 'Users') { &WhoUsers; }
elsif ($INFO{'info'} eq 'Time') { &WhatTime; }
elsif ($INFO{'info'} eq 'IM') { &WhoIM; }
elsif ($INFO{'info'} eq 'Recent') { &WhoRecent; }
elsif ($INFO{'info'} eq 'Stats') { &WhoStats; }
elsif ($INFO{'info'} eq 'Chat') { &WhoChat; }
elsif ($INFO{'info'} eq 'Birthday') { &WhoBirthday; }
elsif ($INFO{'info'} eq 'CalStuff') { &CalStuff; }
elsif ($INFO{'info'} eq 'Menu') { &Menu; }
elsif ($INFO{'info'} eq 'ShowAll') { &ShowAll; }

exit;

sub ShowAll {

&Menu if ($menu eq '1');
&WhatTime if ($what_time eq '1');
&WhoIM if ($who_im eq '1');
&WhoRecent if ($who_recent eq '1');
&WhoStats if ($who_stats eq '1');
&WhoUsers if ($who_users eq '1');
&WhoMembers if ($who_members eq '1');
&CalStuff if ($cal_stuff eq '1');
&WhoBirthday if ($who_birthday eq '1');
&WhoChat if ($who_chat eq '1');

exit;

}

sub WhoHeader {
### This section is taken from YaBB.pl ###
if( $ENV{'SERVER_SOFTWARE'} =~ /IIS/ ) {
	$yyIIS = 1;
	$0 =~ m~(.*)(\\|/)~;
	$yypath = $1;
	$yypath =~ s~\\~/~g;
	chdir($yypath);
	push(@INC,$yypath);
}

use CGI::Carp qw(fatalsToBrowser);
require "Settings.pl";
require "$language";
require "$sourcedir/Subs.pl";
require "$sourcedir/Load.pl";
require "$vardir/WhosonSettings.txt";
use CGI qw/:standard/;
### Load the user's cookie (or set to guest) ###
&LoadCookie;


	if( fopen(FILE, "$memberdir/$username.dat") ) {;
			@settings=<FILE>;
			fclose(FILE);
			for( $_ = 0; $_ < @settings; $_++ ) {
				$settings[$_] =~ s~[\n\r]~~g;
			}
			$realname = $settings[1];
	}

### Prints HTTP headers - based on header in Sub.pl ###
if( $yyForceIIS ) { $headers = "HTTP/1.0 200 OK\n"; }
$headers .= "Content-type: text/html;CHARSET=$yycharset\n\n";
print $headers;

&WriteLog;

}

sub WhatTime {

$yytime = &timeformat($date, 1);

print qq~
<TR><TD>
<FONT SIZE="$textfontsize">
		$yytime
</FONT>
</TD></TR>
~;
}

sub Menu {

	$yyposition = $yytitle; $yytitle = "$mbname - $yytitle";
	if ($defaultml == 0) { $mldefault = "mlall"; }
	elsif ($defaultml == 1) { $mldefault = "mlpost"; }
	elsif ($defaultml == 2) { $mldefault = "mlalfa"; }
	elsif ($defaultml == 3) { $mldefault = "mlgrp"; }

print qq~
<TR>
<TD WIDTH="100%">
~;
if ($home eq '1') {
print qq~
<A HREF="$scripturl">$img{'home'}</a>~;
}
if ($help eq '1') {
print qq~
$who_menusep<A HREF="$scripturl?action=mhelp" style="cursor:help;">$img{'help'}</a>~;
}
if ($search eq '1') {
print qq~
$who_menusep<A HREF="$scripturl?action=search">$img{'search'}</a>~;
}
if ($memberlist eq '1') {
print qq~
$who_menusep<A HREF="$scripturl?action=$mldefault">$img{'memberlist'}</a>~;
}
if ($calendar eq '1') {
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $settings[7] eq $newcalgroup ) {
print qq~
$who_menusep<A HREF="$scripturl?action=newcalendar">$img{'newcalendar'}</a>~;
	}
}
if ($games eq '1') {
print qq~
$who_menusep<A HREF="$scripturl?action=games">$img{'games'}</a>~;
}
if ($admin eq '1') {
if($settings[7] eq 'Administrator') {
print qq~
$who_menusep<A HREF="$scripturl?action=admin">$img{'admin'}</a>~;
}
if($settings[7] eq 'Global Moderator' && $allow_mod == 1) {
print qq~
$who_menusep<A HREF="$scripturl?action=moderate">$img{'moderate'}</a>~;
	}
}
if ($guest_stuff eq '1') {
if($username eq 'Guest') {
print qq~
$who_menusep<A HREF="$scripturl?action=login">$img{'login'}</a>&nbsp;$who_menusep<A HREF="$scripturl?action=register">$img{'register'}</a>~;
	} if($username ne 'Guest') {
	&LoadUser($username);
print qq~
$who_menusep<A HREF="$scripturl?action=profile;username=$useraccount{$username}">$img{'profile'}</a>~;
if($enable_notification) {
print qq~
$who_menusep<A HREF="$scripturl?action=shownotify">$img{'notification'}</a>~;
	}
print qq~
$who_menusep<A HREF="$scripturl?action=logout">$img{'logout'}</a>~;
		}
	}
print qq~
</TD></TR>
~;
}

sub WhoMembers {

	my( $memcount, $latestmember ) = &MembershipGet;
	&LoadUser($latestmember);
	$thelatestmember = qq~<A HREF="$scripturl?action=viewprofile&username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;

print qq~
<TR>
<TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <B>$txt{'331'}</B></FONT></TD>
</TR><TR>
<TD CLASS="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15">
<FONT SIZE="$textfontsize">$txt{'201'}:<BR>
-- $thelatestmember<BR>
   <BR>    
   $whotxt{'12'}:<BR>
    -- <A HREF="$scripturl?action=mlall" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'06'}">$txt{'303'}</A><BR>
	-- <A HREF="$scripturl?action=mlletter" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'07'}">$txt{'304'}</A><BR>
    -- <A HREF="$scripturl?action=mltop" title="$whotxt{'02'} $whotxt{'03'} $whotxt{'04'} $whotxt{'08'}">$txt{'305'} $txt{'411'} $TopAmmount $txt{'306'}</A><BR>
</FONT></TD>
</TR>
~;

}

sub WhoUsers {

	$guests = 0;
	$counter = 0;
	$modcounter = 0;
	$admincounter = 0;
	$users = '';
	$moderators = '';
	$admins = '';

fopen(FILE, "$vardir/log.txt");
@entries = <FILE>;
fclose(FILE);

	foreach $curentry (@entries) {
	chomp $curentry;
	($name, $value) = split(/\|/, $curentry);
	if( $name ) {
		&LoadUser($name);
			if( exists $userprofile{$name} ) {
                 if ($userprofile{$name}->[7] eq "Administrator") {
                       $admins .= qq~ <A HREF="$scripturl?action=viewprofile&username=$useraccount{$name}"><b>$userprofile{$name}->[1]</b></a><FONT SIZE=$textfontsize>,</FONT> \n~;
$admincounter++;

                       } elsif ($userprofile{$name}->[7] eq "Global Moderator") {
                       $moderators .= qq~ <A HREF="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><FONT SIZE=$textfontsize>,</FONT> \n~;
$modcounter++;

                                         } else {
                       $users .= qq~ <A HREF="$scripturl?action=viewprofile&username=$useraccount{$name}">$userprofile{$name}->[1]</a><FONT SIZE=$textfontsize>,</FONT> \n~;
$counter++;
                                         }
                 } else { ++$guests; }
	}
}
	$users =~ s~<FONT SIZE=$textfontsize>,</FONT> \n\Z~~;
	$moderators =~ s~<FONT SIZE=$textfontsize>,</FONT> \n\Z~~;
	$admins =~ s~<FONT SIZE=$textfontsize>,</FONT> \n\Z~~;
	$countonl = $counter + $admincounter + $modcounter + $guests;

	chomp $users;
if($users eq '') {
$users = "<I>$whotxt{'01'}</I>";
	}

	chomp $admins;
if($admins eq '') {
$admins = "<I>$whotxt{'01'}</I>";
	}

	chomp $moderators;
if($moderators eq '') {
$moderators = "<I>$whotxt{'01'}</I>";
	}

if($countonl eq '') {
$countonl = "<I>$whotxt{'01'}</I>";
	}

print qq~
 <TR>
    <TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$txt{'158'}</B></FONT></TD>
  </TR><TR>
    <TD CLASS="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15"><FONT SIZE="$textfontsize">$txt{'94'}: $countonl <BR>
<BR>$txt{'684'}: <BR>&nbsp;&nbsp; $admins
<BR>$whotxt{'14'}: <BR>&nbsp;&nbsp; $moderators
<BR>$txt{'142'}: <BR>&nbsp;&nbsp; $users
<BR>$txt{'141'}: $guests
</FONT></TD>
  </TR>
~;
}

sub WhoIM {

if ($username ne 'Guest') { 

require "$sourcedir/Load.pl";
&LoadIMs;

if ($adv_imbox eq '1') {
print qq~
 <TR>
    <TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$whotxt{'15'}</b></FONT></TD>
  </TR><TR>
    <TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15"><FONT SIZE=$textfontsize>
$txt{'247'}&nbsp;$realname,<BR>$txt{'152'}&nbsp;<A HREF="$cgi;action=im">$minnum
~;
		if($minnum == 1) { print $whotxt{'13'}; }
		else { print $whotxt{'05'}; }
		print qq~
    </A>
$imnewcount $imnewtext
</FONT>
	</TD>
  </TR>
~;
	}

else {
print qq~
 <TR>
    <TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$whotxt{'15'}</b></FONT></TD>
  </TR><TR>
    <TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15"><FONT SIZE=$textfontsize>
$txt{'247'}&nbsp;$realname,<BR>$txt{'152'}&nbsp;<A HREF="$cgi;action=im">$messnum
~;
		if($messnum == 1) { print $txt{'153a'}; }
		else { print $whotxt{'05'}; }
		print qq~
    </A></FONT>
	</TD>
  </TR>
~;
	}
}

else {
### Quick Login Box by Michael ###
print qq~

  <TR>
    <TD class="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$whotxt{'09'}</b></FONT>
    </TD>
  </TR>
  <TR>
    <TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15" ALIGN="left">
      <TABLE>
        <TR>
          <TD width="100%">
            <FONT SIZE="$textfontsize">$txt{'35'}:</FONT>
          </TD>
          <TD ALIGN="left">
            <form action="$scripturl?action=login2" method="POST">
            <input type="hidden" name="cookielength" value="$Cookie_Length">
            <input type=text name="username" size="10">
          </TD>
        </TR>
        <TR>
          <TD width="100%">
            <FONT SIZE="$textfontsize">$txt{'36'}:</FONT>
          </TD>
          <TD ALIGN="left">
            <input type=password name="passwrd" size="10">
          </TD>
        <TR>
          <TD COLSPAN="2" ALIGN="center">
            <FONT SIZE="$textfontsize">$whotxt{'10'} <input type="checkbox" name="cookieneverexp" checked style="background-color: transparent"></FONT>
            <BR><INPUT TYPE="submit" VALUE="$txt{'34'}">
            </FORM>
          </TD>
        </TR>
      </TABLE>
    </TD>
  </TR>
~;
}
###/Quick Login Box ###
}

sub WhoStats {

fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);

  	my( $memcount, $latestmember ) = &MembershipGet;

      print qq~
    <TR>
    <TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$txt{'200'}</b></FONT></TD>
  </TR><TR>  
~;

	$totalm = 0;
	$totalt = 0;

	for( $catnum = 0; $catnum < @categories; $catnum++ ) {
		chomp $categories[$catnum];
		$curcat = $categories[$catnum];
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator' ) {
			$openmemgr{$curcat} = 1;
		}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);
			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}



print qq~
    <TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top" HEIGHT="15">
 			<FONT SIZE="$textfontsize">$txt{'488'}&nbsp; $memcount <BR> 
  			$txt{'489'}&nbsp; $totalm <BR> 
  			$txt{'490'}&nbsp; $totalt 
            </FONT>
    </TD>
</TR>
~;
}

########## Insert Newcalendar Stuff ##########
sub CalStuff {
if(-e("$sourcedir/Newcalendar.pl"))	{
print qq~
 <TR>
    <TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <B>$whotxt{'16'}</B></FONT>
    </TD>
  </TR>
  <TR>
    <TD CLASS="windowbg2" BGCOLOR="$color{'windowbg2'}" VALIGN="top">
      <FONT SIZE="$textfontsize">
~;
require "$sourcedir/Newcalendar.pl";
&WhosCal;
	print qq~
		<BR>
      </FONT>
    </TD>
  </TR>
~;
}
1;
}
######### End Newcalendar Stuff #############

sub WhoRecent {

	@categories = ();
	open(FILE, "$vardir/cat.txt");
	&lock(FILE);
	@categories = <FILE>;
	&unlock(FILE);
	close(FILE);

	$oldestfound = stringtotime("01/10/37 at 00:00:00");

	foreach $curcat (@categories) {
		chomp $curcat;

		open(FILE, "$boardsdir/$curcat.cat");
		&lock(FILE);
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		&unlock(FILE);
		close(FILE);

		$openmemgr{$curcat} = 0;
		@membergroups = split( /,/, $cataccess{$curcat} );
		if( ! $cataccess{$curcat} ) { $openmemgr{$curcat} = 1;	}
		unless( $openmemgr{$curcat} ) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;

			open(FILE, "$boardsdir/$curboard.txt");
			&lock(FILE);
			@threads = <FILE>;
			&unlock(FILE);
			close(FILE);

			open(FILE, "$boardsdir/$curboard.dat");
			&lock(FILE);
			@boardinfo = <FILE>;
			&unlock(FILE);
			close(FILE);
			foreach (@boardinfo) {
				chomp;
			}
			@{$boardinfo{$curboard}} = @boardinfo;
			$cat{$curboard} = $curcat;

			for ($i = 0; $i < @threads; $i++) {
				chomp $threads[$i];

				($tnum, $tsub, $tname, $temail, $tdate, $treplies, $tusername, $ticon, $tstate) = split( /\|/, $threads[$i] );
				open(FILE, "$datadir/$tnum.txt") || next;
				&lock(FILE);
				while( <FILE> ) { $message = $_; }
				# get only the last post for this thread.
				&unlock(FILE);
				close(FILE);

				chomp $message;
				if( $message ) {
					($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns) = split(/\|/,$message);
					$mtime = stringtotime($mdate);
					if( $numfound >= $display && $mtime <= $oldestfound ) {
						next;
					}
					else {
						# Decide if thread should have the "NEW" indicator next to it.
						# Do this by reading the user's log for last read time on thread,
						# and compare to the last post time on the thread.
						$dlp = &getlog($tnum);
						$threaddate = stringtotime($tdate);
						if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
							$tmpx = &getlog("$curboard--mark");
							$new = qq~ <FONT SIZE=$textfontsize color=$new_mark_colour face=$fontface>NEW</FONT>~;
						}
						else { $new = ''; }

						$data{$mtime} = [$curboard, $tnum, $treplies, $tusername, $tname, $tsub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $new];
						if( $mtime < $oldestfound ) { $oldestfound = $mtime; }
						++$numfound;
					}
				}
			}
		}
	}

	@messages = sort {$b <=> $a } keys %data;
	if( @messages ) {
		if( @messages > $display ) { $#messages = $display - 1; }
		$counter = 1;
		open(FILE,"$vardir/censor.txt");
		&lock(FILE);
		while( chomp( $buffer = <FILE> ) ) {
			($tmpa,$tmpb) = split(/=/,$buffer);
			push(@censored,[$tmpa,$tmpb]);
		}
		&unlock(FILE);
		close(FILE);
	}
	else {
		print qq~<hr><b>$whotxt{'48'}</b><hr>~;
	}
	
print qq~
<TR><TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <B>$whotxt{'17'}</B></FONT></TD>
</TR>
<TR><TD CLASS="windowbg2" BGCOLOR="$color{'windowbg2'}">
~;

	for( $i = 0; $i < @messages; $i++ ) {
		($board, $tnum, $c, $tusername, $tname, $msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $message, $mns, $new) = @{ $data{$messages[$i]} };
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$message =~ s~\Q$tmpa\E~$tmpb~gi;
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		if ($snip_headlines) {
			if (length($msub) > $snip_headlines) { $msub = substr($msub,0,$snip_headlines); $msub .= "...";}
		}
print qq~

<FONT FACE="$fontface" color="$fontcolor" size="$textfontsize"><nobr>$counter. </nobr></FONT>&nbsp;
<FONT FACE="$fontface" color="$fontcolor" size="$textfontsize"><A HREF="$scripturl?board=$board;action=display;num=$tnum" target="_parent">$msub</a>$new</FONT><BR>

~;

		++$counter;
	}
	
print qq~
</TD></TR>
~;

sub lock {
	my $lock_file = $_[0];
	my $flag = 1;
	my $count = 0;
	if($use_flock==1) {
		flock($lock_file, $LOCK_EX);
	} elsif ($use_flock==2) {

		while($flag and $count < 15) {
			$flag = check_flock($lock_file);
			$count++;
		}

		unlink($lock_file) if ($count == 15);
		open(LOCK_FILE, ">$lock_file");
	}
}

sub unlock {
	my $lock_file = $_[0];

	if($use_flock==1) {
		flock($lock_file, $LOCK_UN);
	} elsif ($use_flock==2) {
		close(LOCK_FILE);
		unlink($lock_file) if (-e $lock_file);
	}
}

sub stringtotime {
	unless( $_[0] ) { return 0; }
	my( $adate, $atime ) = split(m~ at ~, $_[0]);
	my( $amonth, $aday, $ayear ) = split(m~/~, $adate);
	my( $ahour, $amin, $asec ) = split (m~:~, $atime);
	$asec = int($asec) || 0;
	$amin = int($amin) || 0;
	$ahour = int($ahour) || 0;
	$ayear = int($ayear) || 0;
	$amonth = int($amonth) || 0;
	$aday = int($aday) || 0;
	$ayear += 100;
	if( $amonth < 1 ) { $amonth = 0; }
	elsif( $amonth > 12 ) { $amonth = 11; }
	else { --$amonth; }
	if( $aday < 1 ) { $aday = 1; }
	elsif( $aday > 31 ) { $aday = 31; }
	return( timelocal($asec, $amin, $ahour, $aday, $amonth, $ayear) - (3600*$timeoffset) );
}

sub getlog {
	if( $username eq 'Guest' || $max_log_days_old == 0 ) { return; }
	my $entry = $_[0];
	unless( defined %yyuserlog ) {
		%yyuserlog = ();
		my( $name, $value, $thistime, $adate, $atime, $amonth, $aday, $ayear, $ahour, $amin, $asec );
		my $mintime = time - ( $max_log_days_old * 86400 );
		open(MLOG, "$memberdir/$username.log");
		&lock(MLOG);
		while( <MLOG> ) {
			chomp;
			($name, $value, $thistime) = split( /\|/, $_ );
			unless( $name ) { next; }
			if( $value ) {
				$thistime = stringtotime($value);
			}
			if( $thistime > $mintime ) {
				$yyuserlog{$name} = $thistime;
			}
		}
		&unlock(MLOG);
		close(MLOG);
	}
	return $yyuserlog{$entry};
	}
}

sub WhoChat {
 
if(-e("$sourcedir/Chat.pl"))	{
$cguests = 0;
$cusers = '';
open(OF,"$vardir/online.txt") or dienice ("Can't open file: $!");
@ary = <OF>;
foreach $line (@ary) {
    chomp($line);
        ($of,$name,$ip,$displayname,$level,$time,$non1,$non2) = split(//,$line);
        		if( $name ) {
			if( exists $userprofile{$name} ) {
				$cusers .= qq~ <A HREF="$scripturl?action=viewprofile&username=$name">$displayname</a><FONT SIZE=$textfontsize>,</FONT> \n~;
			}
			else { ++$cguests; }
			}
close(OF);
}
	$cusers =~ s~<FONT SIZE=$textfontsize>,</FONT> \n\Z~~;

	if($cusers eq '') {
		$cusers = "<i>$whotxt{'01'}</i>";
	}

if ($password eq ""){
	$yymain .=qq~<FONT SIZE="$textfontsize">$chadmtxt{'8'}</FONT>~;}
else {
	$yymain .=qq~<A HREF=javascript\:OpenAdsDetail(\'$cgi;action=chatnow\&job=login\',\"$windowname\")>$chadmtxt{'10'}</a>
~;
}

print qq~

<TR><TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <b>$chadmtxt{'7'}</TD>
</TR><TR>
	<TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" HEIGHT="15">&nbsp;&nbsp;<FONT SIZE="$headerfontsize">$cusers</FONT>&nbsp;<BR>
	$yymain
	</TD>
</TR>
</TR><TR>
~;
}
}
sub WhoBirthday {

###############################################
#Birthday mod plugin for YaBB 1Gold           #
#	By Max : staff@my.netvigator.com      #
###############################################

&timeformat($date);
($tocheckm, $tocheckd, $trash) = split(/\//, $date);
$whobd = "";
$countbd = 0;

## get the userlist to check

	open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	close(FILE);
	foreach $usernames (@members) {
	chomp $usernames;
	open(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
	@userbd = <FILE>;
	close(FILE);
		chomp $userbd[16];
		($matchm, $matchd, $trash) = split(/\//, $userbd[16]);
		if(($tocheckm == $matchm) && ($tocheckd == $matchd)) {
		$userbd[6] =~ s/ //g;
		chomp $userbd[6];
$whobg .=qq~<b><A HREF=$cgi;action=viewprofile&username=$usernames title=\"$txt{'27'}\">$userbd[1]</a></b><BR> ~;
			$countbd++;
			}#end if
				}#end foreach
	chomp $whobg;
if($whobg eq '') {
$whobg = "<i>$whotxt{'01'}</i>";
	}
print qq~

<TR><TD CLASS="titlebg" BGCOLOR="$color{'titlebg'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&#187; <B>$whotxt{'11'}</B></FONT></TD>
</TR><TR>
<TD class="windowbg2" BGCOLOR="$color{'windowbg2'}" HEIGHT="15"><FONT SIZE="$headerfontsize">&nbsp;&nbsp; $whobg</FONT>&nbsp;</TD>
</TR>
~;
}

exit;